##
##data1 build bhm data
##

setwd("S:/VID/project/tfrproj3/")

library("dplyr")
data("tfr", package = "wpp2015")
data("UNlocations", package = "wpp2015")

##
##high low
##
for(fn in c("high2015","low2015","unpd2015")){
  df0 <- tfr %>% 
    left_join(UNlocations) %>%
    as_data_frame()
  
  if(fn =="low2015"){
    df0 <- df0 %>%
      mutate(`2010-2015` = ifelse(agcode_947==947 | reg_name %in% c("Southern Asia") | name=="China", 
                                  yes = `2010-2015` * 0.9, no = `2010-2015`))
  }
  if(fn =="high2015"){
    df0 <- df0 %>%
      mutate(`2010-2015` = ifelse(agcode_947==947 | reg_name %in% c("Southern Asia") | name=="China", 
                                  yes = `2010-2015` * 1.1, no = `2010-2015`))
  }
  write.table(df0, paste0("./data/",fn, "_tfr.csv"), sep = "\t")
}
#test

# library("bayesTFR")
# m <- run.tfr.mcmc(seed=1, start.year=1950, present.year = 2015, wpp.year = 2015,
#                   parallel=TRUE, buffer.size = 10000, 
#                   iter=10, #replace.output=TRUE,# iter="auto", 
#                   auto.conf=list(max.loops=20), 
#                   my.tfr.file =  paste0("./data/",fn, "_tfr.csv"))
# #my.locations.file =  paste0("./data/",fn, "_locations.csv"))
# m$meta$tfr_matrix
# m$meta$regions$country_code
# as.character(m$meta$regions$country_name)

##
## different wpp
##

library("dplyr")
library("tidyr")

data("tfr", package = "wpp2015")
df0 <- tfr %>%
  gather(key = period, value = wpp2015, -country_code, -country) %>%
  mutate(country = as.character(country),
         period = as.character(period)) %>%
  filter(period %in% paste(seq(1950,2005,5), seq(1950,2005,5)+5, sep = "-")) %>%
  as_data_frame() 

for(wpp in c(2008, 2010, 2012)){
  #wpp=2008
  data("tfr", package = paste0("wpp",wpp))
  df1 <- tfr %>%
    select(-country) %>%
    gather(key = period, value = temp, -country_code) %>%
    mutate(period = as.character(period)) %>%
    filter(period %in% paste(seq(1950,2005,5), seq(1950,2005,5)+5, sep = "-")) %>%
    as_data_frame() 
  names(df1)[3] <- paste0("wpp",wpp)
  
  df0 <- df0 %>% 
    left_join(df1, by = c("country_code"="country_code", "period"="period" ))
}
df0
df0 %>% filter((is.na(wpp2008) | is.na(wpp2010) | is.na(wpp2012)) & period=="1950-1955")

#update missing countries with wpp2015 data
df1 <- df0 %>% 
  mutate_each(funs(ifelse(is.na(.), yes = wpp2015, no = .)), matches("wpp"))

#write data
for(wpp in c(2008, 2010, 2012, 2015)){
  #wpp=2008
  x <- match(wpp, substring(names(df1),4))
  df2 <- df1 %>% 
    select(c(1:3,x)) 
  names(df2)[4] <- "temp"
  df3 <- df2 %>% spread(key = period, value = temp)
  write.table(df3, paste0(getwd(),"./data/wpp",wpp, "_tfr.csv"), sep = "\t")
}

##
##high low nigeria and kenya
##
for(fn in c("high2015_ken","low2015_ken","high2015_nig", "low2015_nig")){
  df0 <- tfr %>% 
    left_join(UNlocations) %>%
    as_data_frame()
  
  if(fn =="low2015_nig")
    df0 <- df0 %>%
      mutate(`2010-2015` = ifelse(name=="Nigeria", yes = `2010-2015` * 0.9, no = `2010-2015`))
  if(fn =="high2015_nig")
    df0 <- df0 %>%
      mutate(`2010-2015` = ifelse(name=="Nigeria", yes = `2010-2015` * 1.1, no = `2010-2015`))
  if(fn =="low2015_ken")
    df0 <- df0 %>%
      mutate(`2010-2015` = ifelse(name=="Kenya", yes = `2010-2015` * 0.9, no = `2010-2015`))
  if(fn =="high2015_ken")
    df0 <- df0 %>%
      mutate(`2010-2015` = ifelse(name=="Kenya", yes = `2010-2015` * 1.1, no = `2010-2015`))
  write.table(df0, paste0("./data/",fn, "_tfr.csv"), sep = "\t")
}

